.nolist
include \masm32\MasmBasic\MasmBasic.inc	; [url=http://www.masm32.com/board/index.php?topic=12460]download[/url]

.data?
hStatic	dd ?	; static control serves as canvas
ImgCounter	dd ?	; Files$(0...MbGetFileCount)

	Init			; initialise [url=http://www.masm32.com/board/index.php?topic=12460]MasmBasic[/url]
	mov esi, CL$()	; get first arg of commandline
	GfNoRecurse=1	; search only in the current folder
	.if Exist(esi)
		Let esi=Left$(esi, Rinstr(esi, "\"))+"*"+Right$(esi, 4)
		GetFiles esi	; show files with the same extension
	.else
		GetFiles *.jpg	; load Files$() array with
		AddFiles *.png	; typical image files
		AddFiles *.gif
	.endif
	call WinMain
	Exit

WinMain proc
LOCAL msg:MSG, wcex:WNDCLASSEX
	call ClearLocVars	; zero WNDCLASSEX
	ebxNull equ <ebx>
	xor ebx, ebx	; ebxNull
	lea esi, wcex
	wc equ <[esi.WNDCLASSEX]>
	m2m wc.cbSize, WNDCLASSEX
	m2m wc.style, CS_HREDRAW or CS_VREDRAW
	mov wc.lpfnWndProc, offset WndProc
	m2m wc.hbrBackground, COLOR_BTNFACE+1
	mov wc.lpszClassName, Chr$("MB GUI")
	mov wc.hInstance, rv(GetModuleHandle, ebxNull)
	mov wc.hIcon, rv(LoadIcon, eax, IDI_APPLICATION)	; eax=hInstance
	mov wc.hIconSm, eax
	mov wc.hCursor, rv(LoadCursor, ebxNull, IDC_ARROW)
	invoke RegisterClassEx, esi
	invoke CreateWindowEx, WS_EX_CLIENTEDGE,
		wc.lpszClassName, ebxNull,
		WS_CAPTION or WS_THICKFRAME or WS_CLIPCHILDREN or WS_VISIBLE,
		-127, -127, ebxNull, ebxNull,\	; for now, outside of visible screen
		ebxNull, ebxNull, wc.hInstance, ebxNull
	invoke CreateWindowEx, ebxNull, Chr$("static"), ebxNull,
		WS_CHILD or WS_VISIBLE, ebxNull, ebxNull, ebxNull, ebxNull,
		eax, 123, wc.hInstance, ebxNull	; eax=retval cwex main, 123=IdStatic
	mov hStatic, eax
	add esi, wc.cbSize	; lea esi, msg but one byte shorter ;-)
	.Repeat
		invoke GetMessage, esi, ebxNull, ebxNull, ebxNull
		.Break .if !eax
			; invoke TranslateMessage, esi
			invoke DispatchMessage, esi
	.Until 0
	ret
WinMain endp

WndProc proc uses edi esi ebx hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
LOCAL rc:RECT, pt:POINT

  SWITCH uMsg
  CASE WM_DESTROY
	invoke PostQuitMessage, NULL

  CASE WM_KEYUP
  	call ArrowHandler	; left/up=previous, right down=next image, [Ctrl] PageDown/Up, Home, End

  CASE WM_SIZE
	call CenterImage	; resize window to fit image #1

  CASE WM_GETMINMAXINFO
  	mov eax, lParam
  	and [eax.MINMAXINFO.ptMinTrackSize.x], 0	; for very small fotos, e.g. icons
  	and [eax.MINMAXINFO.ptMinTrackSize.y], 0

  CASE WM_PAINT
	invoke GetClientRect, hWnd, addr rc
	invoke MoveWindow, hStatic, 0, 0, rc.right, rc.bottom, 0
	invoke InvalidateRect, hStatic, 0, 0
	mov esi, Files$(ImgCounter)
	ImgPaint hStatic, 0, esi		; <<<< GdiPlus GdipDrawImageRectI wrapper
		SetWin$(hWnd)="Viewing "+esi

  ENDSW
  invoke DefWindowProc, hWnd, uMsg, wParam, lParam
  ret

CenterImage:
  .if !GdipLoaded[4]
	mov esi, GetSystemMetrics
	push SM_CYCAPTION
	call esi
	push eax
	push SM_CYFULLSCREEN
	call esi
	push eax
	push SM_CXFULLSCREEN
	call esi
	push eax
	ImgPaintInfo 0,  Files$(ImgCounter)	; get width and height of slot 0 in eax and edx
	add eax, 11	; available screen width
	xchg eax, esi	; esi=width of image
	add edx, 10
	xchg edx, ebx	; ebx=height
	pop eax			; screen width
	mov edx, eax
	sub eax, esi	; minus pic width
	sar eax, 1		; divide by 2
	mov pt.x, eax	; default:
	cmp edx, esi
	.if Sign?
		xchg edx, esi
		and pt.x, 0	; default
	.endif
	pop eax			; screen height
	pop edx			; caption
	add ebx, edx
	mov edx, eax
	sub eax, ebx
	sar eax, 1
	mov pt.y, eax	; default
	cmp edx, ebx
	.if Sign?
		xchg edx, ebx
		and pt.y, 0
	.endif
	invoke MoveWindow, hWnd, pt.x, pt.y, esi, ebx, 1
  .endif
  retn 0

ArrowHandler:
	mov ebx, ImgCounter
	invoke GetKeyState, VK_CONTROL
	movsx ecx, ax
	mov eax, wParam
	.if eax==VK_LEFT || eax==VK_UP || eax==VK_PRIOR
		.if eax==VK_PRIOR
			sub ebx, 9
			test ecx, ecx
			.if Sign?
				sub ebx, 40
			.endif
		.endif
  @@:	dec ebx
		.if Sign?
			xor ebx, ebx
		.endif
	.elseif eax==VK_RIGHT || eax==VK_DOWN || eax==VK_NEXT
		.if eax==VK_NEXT
			add ebx, 9
			test ecx, ecx
			.if Sign?
				add ebx, 40
			.endif
		.endif
		inc ebx
		mov eax, MbGetFileCount
		.if ebx>=eax
			dec eax
			xchg eax, ebx
		.endif
		test Len(Files$(ebx)), eax
		je @B
	.elseif eax==VK_END
		mov ebx, MbGetFileCount
		jmp @B
	.elseif eax==VK_HOME
		xor ebx, ebx
	.elseif eax==VK_ESCAPE
		sm hWnd, WM_CLOSE, 0, 0			; Escape: exit without asking!
	.endif
	.if ebx!=ImgCounter
		mov ImgCounter, ebx
		ImgPaintClr 0
		invoke InvalidateRect, hWnd, 0, 1
	.endif
	retn 0
WndProc endp

end start

		For_ n=0 To eax-1
			PrintLine Str$(n), Tb$, Files$(n)
		Next 

RichMasm proc options
OPT_Tmp2Asm	1		; create an asm file for those who don't use RichMasm
OPT_Icon	Eye
OPT_Arg1	Icons\Globe.ico
OPT_Susy	Windows
OPT_Assembler	ml
